## waylandpp 1.0.1

=== CMakeLists.txt ===
# Copyright (c) 2014-2022 Philipp Kerling, Nils Christopher Brause, Craig Andrews, Tobias Kortkamp, Balint Reczey
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.4...4.0)
project(waylandpp VERSION 1.0.1 LANGUAGES CXX)

# packages
include(FindPkgConfig)
include(GNUInstallDirs)
include(CMakeDependentOption)
include(CMakePackageConfigHelpers)
find_package(Doxygen)

# version information
configure_file(include/wayland-version.hpp.in wayland-version.hpp @ONLY)

# path shorthands
set(INSTALL_FULL_PKGCONFIGDIR "${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig")
set(INSTALL_FULL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/waylandpp")

# user options
option(BUILD_SCANNER "whether to build wayland-scanner++" ON)
option(BUILD_LIBRARIES "whether to build the libraries" ON)
cmake_dependent_option(BUILD_SHARED_LIBS "Build shared libraries" ON
  "BUILD_LIBRARIES" OFF)
option(BUILD_DOCUMENTATION "Create and install the HTML based API documentation (requires Doxygen)" ${DOXYGEN_FOUND})
option(INSTALL_UNSTABLE_PROTOCOLS "whether to install the unstable protocols" ON)
cmake_dependent_option(BUILD_EXAMPLES
  "whether to build the examples (requires BUILD_LIBRARIES to be ON)" OFF
  "BUILD_LIBRARIES" OFF)
option(BUILD_SERVER "whether to build the server bindings." ON)

# Do not report undefined references in libraries, since the protocol libraries cannot be used on their own.
if(CMAKE_SHARED_LINKER_FLAGS)
  string(REPLACE "-Wl,--no-undefined" " " CMAKE_SHARED_LINKER_FLAGS ${CMAKE_SHARED_LINKER_FLAGS})
endif()

# variables for .pc.in files
set(prefix "${CMAKE_INSTALL_PREFIX}")
set(bindir "${CMAKE_INSTALL_FULL_BINDIR}")
set(datarootdir "${CMAKE_INSTALL_FULL_DATAROOTDIR}")
set(pkgdatadir "${INSTALL_FULL_PKGDATADIR}")
set(libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")

set(install_namespace "Waylandpp")

# C++ 11
set(CMAKE_CXX_STANDARD 11)

# sets ${PREFIX}_LIBRARIES to the libraries' full path
function(pkg_libs_full_path PREFIX)
  if(${PREFIX}_FOUND)
    unset(LIBS_TMP CACHE)
    foreach(LIB ${${PREFIX}_LIBRARIES})
      unset(LIB_TMP CACHE)
      find_library(LIB_TMP ${LIB} PATHS ${${PREFIX}_LIBRARY_DIRS})
      list(APPEND LIBS_TMP ${LIB_TMP})
    endforeach()
    set(${PREFIX}_LIBRARIES ${LIBS_TMP} PARENT_SCOPE)
  endif()
endfunction()

# AdressSanitizer support
set(CMAKE_C_FLAGS_ASAN "-fsanitize=address -fno-optimize-sibling-calls -fsanitize-address-use-after-scope -fno-omit-frame-pointer -g -O0")
set(CMAKE_CXX_FLAGS_ASAN "-fsanitize=address -fno-optimize-sibling-calls -fsanitize-address-use-after-scope -fno-omit-frame-pointer -g -O0")

# build scanner
if(BUILD_SCANNER)
  pkg_check_modules(PUGIXML REQUIRED "pugixml>=1.4")
  pkg_libs_full_path(PUGIXML)
  add_executable(wayland-scanner++ scanner/scanner.cpp)
  target_link_libraries(wayland-scanner++ ${PUGIXML_LIBRARIES})
  target_compile_options(wayland-scanner++ PUBLIC ${PUGIXML_CFLAGS})
  configure_file(wayland-scanner++.pc.in wayland-scanner++.pc @ONLY)
  install(TARGETS wayland-scanner++ RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_BINDIR}")
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/wayland-scanner++.pc" DESTINATION "${INSTALL_FULL_PKGCONFIGDIR}")
endif()

# build libraries
if(BUILD_LIBRARIES)
  # if we are crosscompiling, the scanner has to build and installed already
  if(CMAKE_CROSSCOMPILING OR (NOT BUILD_SCANNER))
    set(WAYLAND_SCANNERPP "WAYLAND_SCANNERPP-NOTFOUND" CACHE FILEPATH "Path to wayland-scanner++")
    if(NOT WAYLAND_SCANNERPP)
      message(SEND_ERROR "If you cross-compile or do not build the scanner, you have to specify the path to a native wayland-scanner++ executable in the WAYLAND_SCANNERPP variable.")
    endif()
  else()
    set(WAYLAND_SCANNERPP wayland-scanner++)
  endif()

  # required libraries
  pkg_check_modules(WAYLAND_CLIENT REQUIRED "wayland-client>=1.11.0")
  if(BUILD_SERVER)
    pkg_check_modules(WAYLAND_SERVER REQUIRED "wayland-server>=1.17.0")
  endif()
  pkg_check_modules(WAYLAND_EGL REQUIRED wayland-egl)
  pkg_libs_full_path(WAYLAND_EGL)
  pkg_check_modules(WAYLAND_CURSOR REQUIRED wayland-cursor)
  pkg_libs_full_path(WAYLAND_CURSOR)

  # generate protocol source/headers from protocol XMLs
  set(PROTO_XMLS "${CMAKE_SOURCE_DIR}/protocols/wayland.xml")
  file(GLOB PROTO_XMLS_EXTRA "${CMAKE_SOURCE_DIR}/protocols/extra/*.xml")
  file(GLOB PROTO_XMLS_UNSTABLE "${CMAKE_SOURCE_DIR}/protocols/unstable/*.xml")
  set(PROTO_FILES
    "wayland-client-protocol.hpp"
    "wayland-client-protocol.cpp")
  set(PROTO_FILES_EXTRA
    "wayland-client-protocol-extra.hpp"
    "wayland-client-protocol-extra.cpp")
  set(PROTO_FILES_UNSTABLE
    "wayland-client-protocol-unstable.hpp"
    "wayland-client-protocol-unstable.cpp")
  add_custom_command(
    OUTPUT ${PROTO_FILES}
    COMMAND "${WAYLAND_SCANNERPP}" ${PROTO_XMLS} ${PROTO_FILES}
    DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS})
  add_custom_command(
    OUTPUT ${PROTO_FILES_EXTRA}
    COMMAND "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_EXTRA} ${PROTO_FILES_EXTRA}
    DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_EXTRA})
  add_custom_command(
    OUTPUT ${PROTO_FILES_UNSTABLE}
    COMMAND "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_UNSTABLE} "-x" "wayland-client-protocol-extra.hpp"
    DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_EXTRA})

  if(BUILD_SERVER)
    set(PROTO_FILES
      "wayland-server-protocol.hpp"
      "wayland-server-protocol.cpp")
    set(PROTO_FILES_EXTRA
      "wayland-server-protocol-extra.hpp"
      "wayland-server-protocol-extra.cpp")
    set(PROTO_FILES_UNSTABLE
      "wayland-server-protocol-unstable.hpp"
      "wayland-server-protocol-unstable.cpp")
    add_custom_command(
      OUTPUT ${PROTO_FILES}
      COMMAND "${WAYLAND_SCANNERPP}" "-s" "on" ${PROTO_XMLS} ${PROTO_FILES}
      DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS})
    add_custom_command(
      OUTPUT ${PROTO_FILES_EXTRA}
      COMMAND "${WAYLAND_SCANNERPP}" "-s" "on" ${PROTO_XMLS_EXTRA} ${PROTO_FILES_EXTRA} "-x" "wayland-server-protocol.hpp"
      DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_EXTRA})
    add_custom_command(
      OUTPUT ${PROTO_FILES_UNSTABLE}
      COMMAND "${WAYLAND_SCANNERPP}" "-s" "on" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_UNSTABLE} "-x" "wayland-server-protocol-extra.hpp"
      DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_EXTRA})
  endif()

  # library building helper functions
  function(define_library TARGET CFLAGS LIBRARIES HEADERS)
    add_library("${TARGET}" ${ARGN})
    add_library(${install_namespace}::${TARGET} ALIAS ${TARGET})
    get_target_property(libtype "${TARGET}" TYPE)
    target_include_directories("${TARGET}" PUBLIC
      "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include;${CMAKE_CURRENT_BINARY_DIR}>" # latter for wayland-version.hpp
      $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
      )
    target_compile_options("${TARGET}" PUBLIC ${CFLAGS})
    target_link_libraries("${TARGET}" PUBLIC ${LIBRARIES})
    set_target_properties("${TARGET}" PROPERTIES
      PUBLIC_HEADER "${HEADERS}"
      VERSION "${PROJECT_VERSION}"
      SOVERSION ${PROJECT_VERSION_MAJOR})
    configure_file("${TARGET}.pc.in" "${TARGET}.pc" @ONLY)
    set_target_properties("${TARGET}" PROPERTIES RESOURCE "${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc")
  endfunction()

  define_library(wayland-client++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LIBRARIES}"
    "include/wayland-client.hpp;include/wayland-util.hpp;${CMAKE_CURRENT_BINARY_DIR}/wayland-client-protocol.hpp;${CMAKE_CURRENT_BINARY_DIR}/wayland-version.hpp"
    src/wayland-client.cpp src/wayland-util.cpp wayland-client-protocol.cpp wayland-client-protocol.hpp)
  # Report undefined references only for the base library.
  if(${CMAKE_VERSION} VERSION_GREATER "3.14.0")
    target_link_options(wayland-client++ PRIVATE "-Wl,--no-undefined")
  endif()
  if(BUILD_SERVER)
    define_library(wayland-server++ "${WAYLAND_SERVER_CFLAGS}" "${WAYLAND_SERVER_LIBRARIES}"
      "include/wayland-server.hpp;include/wayland-util.hpp;${CMAKE_CURRENT_BINARY_DIR}/wayland-server-protocol.hpp"
      src/wayland-server.cpp src/wayland-util.cpp wayland-server-protocol.cpp wayland-server-protocol.hpp)
    # Report undefined references only for the base library.
    if(${CMAKE_VERSION} VERSION_GREATER "3.14.0")
      target_link_options(wayland-server++ PRIVATE "-Wl,--no-undefined")
    endif()
    define_library(wayland-server-extra++ "${WAYLAND_SERVER_CFLAGS}" "${WAYLAND_SERVER_LIBRARIES}"
      "${CMAKE_CURRENT_BINARY_DIR}/wayland-server-protocol-extra.hpp"
      wayland-server-protocol-extra.cpp wayland-server-protocol-extra.hpp wayland-server-protocol.hpp)
    target_link_libraries(wayland-server-extra++ INTERFACE wayland-server++)
    define_library(wayland-server-unstable++ "${WAYLAND_SERVER_CFLAGS}" "${WAYLAND_SERVER_LIBRARIES}"
      "${CMAKE_CURRENT_BINARY_DIR}/wayland-server-protocol-unstable.hpp"
      wayland-server-protocol-unstable.cpp wayland-server-protocol-unstable.hpp wayland-server-protocol.hpp)
    target_link_libraries(wayland-server-unstable++ INTERFACE wayland-server-extra++)
  endif()
  define_library(wayland-client-extra++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LIBRARIES}"
    "${CMAKE_CURRENT_BINARY_DIR}/wayland-client-protocol-extra.hpp"
    wayland-client-protocol-extra.cpp wayland-client-protocol-extra.hpp wayland-client-protocol.hpp)
  target_link_libraries(wayland-client-extra++ INTERFACE wayland-client++)
  define_library(wayland-client-unstable++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LIBRARIES}"
    "${CMAKE_CURRENT_BINARY_DIR}/wayland-client-protocol-unstable.hpp"
    wayland-client-protocol-unstable.cpp wayland-client-protocol-unstable.hpp wayland-client-protocol.hpp)
  target_link_libraries(wayland-client-unstable++ INTERFACE wayland-client-extra++)
  define_library(wayland-egl++ "${WAYLAND_EGL_CFLAGS}" "${WAYLAND_EGL_LIBRARIES}" include/wayland-egl.hpp src/wayland-egl.cpp wayland-client-protocol.hpp)
  target_link_libraries(wayland-egl++ INTERFACE wayland-client++)
  define_library(wayland-cursor++ "${WAYLAND_CURSOR_CFLAGS}" "${WAYLAND_CURSOR_LIBRARIES}" include/wayland-cursor.hpp src/wayland-cursor.cpp wayland-client-protocol.hpp)
  target_link_libraries(wayland-cursor++ INTERFACE wayland-client++)

  # Install libraries
  install(FILES ${PROTO_XMLS} ${PROTO_XMLS_EXTRA} ${PROTO_XMLS_UNSTABLE} DESTINATION "${INSTALL_FULL_PKGDATADIR}/protocols")
  list(APPEND INSTALL_TARGETS wayland-client++ wayland-client-extra++ wayland-egl++ wayland-cursor++)
  if (INSTALL_UNSTABLE_PROTOCOLS)
	  list(APPEND INSTALL_TARGETS wayland-client-unstable++)
    if(BUILD_SERVER)
	    list(APPEND INSTALL_TARGETS wayland-server-unstable++)
    endif()
  endif()

=== example/CMakeLists.txt ===
# Copyright (c) 2014-2022 Philipp Kerling, Nils Christopher Brause
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# dependencies
find_package(Threads REQUIRED)
find_package(OpenGL REQUIRED)
include(FindPkgConfig)
pkg_check_modules(EGL REQUIRED egl)
find_library(LIBRT rt)
mark_as_advanced(LIBRT)

# examples
add_executable(dump dump.cpp)
target_link_libraries(dump wayland-client++)

add_executable(egl egl.cpp)
target_link_libraries(egl wayland-client++ wayland-client-extra++ wayland-cursor++ wayland-egl++ "${OPENGL_LIBRARY}" ${EGL_LDFLAGS})
target_include_directories(egl PUBLIC "${OPENGL_INCLUDE_DIR}")
target_compile_options(egl PUBLIC ${EGL_CFLAGS})

add_executable(foreign_display foreign_display.cpp)
target_link_libraries(foreign_display wayland-client++)

add_executable(proxy_wrapper proxy_wrapper.cpp)
target_link_libraries(proxy_wrapper wayland-client++ Threads::Threads)

add_executable(shm shm.cpp)
target_link_libraries(shm wayland-client++ wayland-client-extra++ wayland-cursor++)

if(BUILD_SERVER)
  set(WAYLAND_SCANNERPP wayland-scanner++)
  set(PROTO_XML "${CMAKE_SOURCE_DIR}/example/pingpong.xml")
  set(CLIENT_PROTO_FILES "pingpong-client-protocol.hpp" "pingpong-client-protocol.cpp")
  set(SERVER_PROTO_FILES "pingpong-server-protocol.hpp" "pingpong-server-protocol.cpp")
  add_custom_command(OUTPUT ${CLIENT_PROTO_FILES} COMMAND "${WAYLAND_SCANNERPP}" ${PROTO_XML} ${CLIENT_PROTO_FILES} DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XML})
  add_custom_command(OUTPUT ${SERVER_PROTO_FILES} COMMAND "${WAYLAND_SCANNERPP}" "-s" "on" ${PROTO_XML} ${SERVER_PROTO_FILES} DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XML})
  add_executable(pingpong pingpong.cpp pingpong-client-protocol.cpp pingpong-server-protocol.cpp)
  target_link_libraries(pingpong wayland-client++ wayland-server++ Threads::Threads)
  target_include_directories(pingpong PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
endif()

if(LIBRT)
  target_link_libraries(shm "${LIBRT}")
endif()

=== example/Makefile ===
# Copyright (c) 2014-2022 Nils Christopher Brause, Philipp Kerling
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

CXX = g++
CXXFLAGS = -std=c++11 -Wall -Werror -ggdb -O2 `pkg-config --cflags --libs ${LIBS}`
SRC = egl.cpp shm.cpp dump.cpp proxy_wrapper.cpp foreign_display.cpp server.cpp

all: $(patsubst %.cpp,%,${SRC})

egl: LIBS = wayland-client++ wayland-client-extra++ wayland-cursor++ wayland-egl++
egl: FLAGS = -lEGL -lGL
shm: LIBS = wayland-client++ wayland-client-extra++ wayland-cursor++
shm: FLAGS = -lrt
dump: LIBS = wayland-client++
proxy_wrapper: LIBS = wayland-client++
proxy_wrapper: FLAGS = -pthread
foreign_display: LIBS = wayland-client++
server: LIBS = wayland-server++

%: %.cpp Makefile
	${CXX} $< ${CXXFLAGS} ${FLAGS} -o $@

clean: Makefile
	rm -f $(patsubst %.cpp,%,${SRC})

.SUFFIXES:

=== debian/changelog ===
waylandpp (1.0.1-1) unstable; urgency=medium

  * New upstream version 1.0.1
  * updated the debian patch

 -- Georges Khaznadar <georgesk@debian.org>  Thu, 14 Aug 2025 11:19:23 +0200

=== debian/control ===
Source: waylandpp
Maintainer: Georges Khaznadar <georgesk@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               pkg-config,
               pkg-kde-tools,
               libpugixml-dev,
               libwayland-dev,
               libegl1,
               libegl1-mesa-dev,
               wayland-scanner++:any <cross>,
	       doxygen,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian/waylandpp
Vcs-Git: https://salsa.debian.org/debian/waylandpp.git
Homepage: https://github.com/NilsBrause/waylandpp

Package: waylandpp-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libwayland-client++1 (= ${binary:Version}),
         libwayland-client-extra++1 (= ${binary:Version}),
         libwayland-cursor++1 (= ${binary:Version}),
         libwayland-egl++1 (= ${binary:Version}),
         libwayland-server++1 (= ${binary:Version}),
         wayland-scanner++:any (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Recommends: waylandpp-doc
Description: wayland compositor infrastructure - C++ development files
 Wayland is a protocol for a compositor to talk to its clients as well
 as a C library implementation of that protocol. The compositor can be
 a standalone display server running on Linux kernel modesetting and
 evdev input devices, an X application, or a wayland client
 itself. The clients can be traditional applications, X servers
 (rootless or fullscreen) or other display servers.
 .
 This package ships the C++ bindings for the development libraries.

Package: waylandpp-doc
Architecture: all
Section: libdevel
Conflicts: waylandpp-dev (<< 1.0.0)
Replaces: waylandpp-dev (<< 1.0.0)
Description: wayland compositor documentation
 Wayland is a protocol for a compositor to talk to its clients as well
 as a C library implementation of that protocol. The compositor can be
 a standalone display server running on Linux kernel modesetting and
 evdev input devices, an X application, or a wayland client
 itself. The clients can be traditional applications, X servers
 (rootless or fullscreen) or other display servers.
 .
 This package ships documentation for the development libraries.

Package: wayland-scanner++
Architecture: any
Multi-Arch: allowed
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: wayland compositor infrastructure - C++ protocol code generator
 Wayland is a protocol for a compositor to talk to its clients as well
 as a C library implementation of that protocol. The compositor can be
 a standalone display server running on Linux kernel modesetting and
 evdev input devices, an X application, or a wayland client
 itself. The clients can be traditional applications, X servers
 (rootless or fullscreen) or other display servers.
 .
 This package ships the C++ code generator binary.

Package: libwayland-client++1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Conflicts: libwayland-client++0
Replaces: libwayland-client++0
Description: wayland compositor infrastructure - client library C++ bindings
 Wayland is a protocol for a compositor to talk to its clients as well
 as a C library implementation of that protocol. The compositor can be
 a standalone display server running on Linux kernel modesetting and
 evdev input devices, an X application, or a wayland client
 itself. The clients can be traditional applications, X servers
 (rootless or fullscreen) or other display servers.
 .
 This package ships the C++ bindings for the client side library of
 the Wayland protocol.

Package: libwayland-client-extra++1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Conflicts: libwayland-client-extra++0
Replaces: libwayland-client-extra++0
Description: wayland compositor infrastructure - client library extra C++ bindings
 Wayland is a protocol for a compositor to talk to its clients as well
 as a C library implementation of that protocol. The compositor can be
 a standalone display server running on Linux kernel modesetting and
 evdev input devices, an X application, or a wayland client
 itself. The clients can be traditional applications, X servers
 (rootless or fullscreen) or other display servers.
 .
 This package ships the C++ bindings for the client side libraries of
 the extra Wayland protocols.

Package: libwayland-cursor++1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Conflicts: libwayland-cursor++0
Replaces: libwayland-cursor++0
Description: wayland compositor infrastructure - cursor library C++ bindings
 Wayland is a protocol for a compositor to talk to its clients as well
 as a C library implementation of that protocol. The compositor can be
 a standalone display server running on Linux kernel modesetting and
 evdev input devices, an X application, or a wayland client
 itself. The clients can be traditional applications, X servers
 (rootless or fullscreen) or other display servers.
 .
 This package ships the C++ bindings for the library of
 the Wayland protocol to manage cursors.

Package: libwayland-egl++1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Conflicts: libwayland-egl++0
Replaces: libwayland-egl++0
Description: wayland compositor infrastructure - EGL library C++ bindings
 Wayland is a protocol for a compositor to talk to its clients as well
 as a C library implementation of that protocol. The compositor can be
 a standalone display server running on Linux kernel modesetting and
 evdev input devices, an X application, or a wayland client
 itself. The clients can be traditional applications, X servers
 (rootless or fullscreen) or other display servers.
 .
 This package ships the C++ bindings for the library which implements the
 Wayland EGL platform of the Wayland protocol.

Package: libwayland-server++1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Conflicts: libwayland-server++0
Replaces: libwayland-server++0
Description: wayland compositor infrastructure - EGL library C++ bindings
 Wayland is a protocol for a compositor to talk to its clients as well
 as a C library implementation of that protocol. The compositor can be
 a standalone display server running on Linux kernel modesetting and
 evdev input devices, an X application, or a wayland client
 itself. The clients can be traditional applications, X servers
 (rootless or fullscreen) or other display servers.
 .
 This package ships the C++ bindings for the library which implements the
 Wayland server.
